'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _HorizontalWrapper = require('./HorizontalWrapper');

var _HorizontalWrapper2 = _interopRequireDefault(_HorizontalWrapper);

var _propTypes = require('./propTypes');

var customTypes = _interopRequireWildcard(_propTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LightweightRow = function LightweightRow(_ref) {
  var thisRowClassName = _ref.className;
  var ContentComponent = _ref.contentComponent;
  var thisContentClassName = _ref.contentClassName;
  var horizontalTransform = _ref.horizontalTransform;
  var _ref$isFastScrolling = _ref.isFastScrolling;
  var isFastScrolling = _ref$isFastScrolling === undefined ? false : _ref$isFastScrolling;
  var isHeader = _ref.isHeader;
  var onClick = _ref.onClick;
  var passthroughOffsets = _ref.passthroughOffsets;
  var rowHeight = _ref.rowHeight;
  var _ref$rowProps = _ref.rowProps;
  var rowProps = _ref$rowProps === undefined ? {} : _ref$rowProps;
  var width = _ref.width;

  var rowStyle = {
    height: rowHeight + 'px',
    width: width + 'px'
  };

  var contentComponent = void 0;
  if (horizontalTransform !== undefined && !isHeader) {
    contentComponent = passthroughOffsets ? _react2.default.createElement(ContentComponent, _extends({
      isFastScrolling: isFastScrolling,
      key: 'content',
      offset: horizontalTransform || 0
    }, rowProps)) : _react2.default.createElement(
      _HorizontalWrapper2.default,
      { key: 'content', offset: horizontalTransform || 0 },
      _react2.default.createElement(ContentComponent, _extends({ isFastScrolling: isFastScrolling }, rowProps))
    );
  } else {
    contentComponent = _react2.default.createElement(ContentComponent, _extends({ key: 'content' }, rowProps));
  }

  var rowClassName = (0, _classnames2.default)('rickscroll__row', thisRowClassName);
  var contentClassName = (0, _classnames2.default)('rickscroll__content', thisContentClassName);

  return _react2.default.createElement(
    'div',
    { className: rowClassName, onClick: onClick, style: rowStyle },
    _react2.default.createElement(
      'span',
      { className: contentClassName, key: 'content-wrapper' },
      contentComponent
    )
  );
};

exports.default = LightweightRow;


LightweightRow.propTypes = {
  className: _react.PropTypes.string,
  contentClassName: _react.PropTypes.string,
  contentComponent: customTypes.renderableComponent,
  horizontalTransform: _react.PropTypes.number,
  isFastScrolling: _react.PropTypes.bool,
  isHeader: _react.PropTypes.bool,
  onClick: _react.PropTypes.func,
  passthroughOffsets: _react.PropTypes.bool,
  rowHeight: _react.PropTypes.number.isRequired,
  rowProps: _react.PropTypes.object,
  width: _react.PropTypes.number.isRequired
};