'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _animationTimer = require('animation-timer');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _functionalEasing = require('functional-easing');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _constants = require('./constants');

var constants = _interopRequireWildcard(_constants);

var _propTypes = require('./propTypes');

var customTypes = _interopRequireWildcard(_propTypes);

var _LightweightRow = require('./LightweightRow');

var _LightweightRow2 = _interopRequireDefault(_LightweightRow);

var _models = require('./models');

var _Row = require('./Row');

var _Row2 = _interopRequireDefault(_Row);

var _utils = require('./utils');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var easer = new _functionalEasing.Easer().using('out-cubic');

var Scrollable = function (_React$Component) {
  _inherits(Scrollable, _React$Component);

  function Scrollable(props) {
    _classCallCheck(this, Scrollable);

    var _this = _possibleConstructorReturn(this, (Scrollable.__proto__ || Object.getPrototypeOf(Scrollable)).call(this, props));

    ['_applyScrollChange', '_getBottomGutterHeight', '_getContentWidth', '_getDimensions', '_getThrottledAnimationFrameFn', '_getTopGutterHeight', '_getWeightedWidth', '_onHorizontalScroll', '_onResize', '_onMouseWheel', '_onVerticalScroll', '_renderContents', '_renderCorner', '_renderHorizontalScrollbar', '_renderHeader', '_renderVerticalScrollbar', '_shouldRenderScrollbars', '_startResize', '_stopResize', '_switchScrollProp', 'scrollRowToMiddle', 'scrollToHeader', 'toggleSection'].forEach(function (method) {
      _this[method] = _this[method].bind(_this);
    });
    _this._onThrottledMouseWheel = _lodash2.default.throttle(_this._applyScrollChange, constants.ANIMATION_FPS_120, { trailing: true });
    _this._endScroll = _lodash2.default.debounce(function () {
      return _this.setState({
        isFastScrolling: false,
        isScrolling: false,
        velocityQueue: [[0, 0]]
      });
    }, 50, { trailing: true });
    _this._endVerticalScroll = _lodash2.default.debounce(function () {
      return _this.setState({
        isFastScrolling: false,
        isScrolling: false,
        velocityQueue: [[0, 0]]
      });
    }, 200, { trailing: true });
    var _props$headerType = props.headerType;
    var headerType = _props$headerType === undefined ? constants.headerType.DEFAULT : _props$headerType;
    var height = props.height;
    var list = props.list;
    var lists = props.lists;
    var width = props.width;

    var stackingHeaders = headerType === constants.headerType.STACKING;
    var listContainer = list || lists;

    var _buildRowConfig = (0, _utils.buildRowConfig)(listContainer, stackingHeaders);

    var avgRowHeight = _buildRowConfig.avgRowHeight;
    var collapsedSections = _buildRowConfig.collapsedSections;
    var contentHeight = _buildRowConfig.contentHeight;
    var headers = _buildRowConfig.headers;
    var partitions = _buildRowConfig.partitions;
    var rowOffsets = _buildRowConfig.rowOffsets;
    var rows = _buildRowConfig.rows;

    var _this$_getDimensions = _this._getDimensions(avgRowHeight, contentHeight, height, width);

    var displayBuffer = _this$_getDimensions.displayBuffer;
    var shouldRender = _this$_getDimensions.shouldRender;


    _this.state = {
      animation: null,
      avgRowHeight: avgRowHeight,
      collapsedSections: collapsedSections,
      contentHeight: contentHeight,
      displayBuffer: displayBuffer,
      isFastScrolling: false,
      headers: headers,
      horizontalTransform: 0,
      partitions: partitions,
      resize: {
        basePosition: 0,
        currentPosition: 0,
        performing: false,
        side: '',
        startingPosition: 0
      },
      rowOffsets: rowOffsets,
      rows: rows,
      isScrolling: false,
      scrollingToPosition: new _models.Point(0, 0),
      shouldRender: shouldRender,
      topPartitionIndex: 0,
      velocityQueue: [[0, 0]],
      verticalTransform: 0
    };
    return _this;
  }

  _createClass(Scrollable, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var scrollToWithoutDefaults = this.props.scrollTo;


      if (!scrollToWithoutDefaults) {
        return;
      }

      this._switchScrollProp(_lodash2.default.merge(_lodash2.default.cloneDeep(constants.defaultScrollTo), _lodash2.default.cloneDeep(scrollToWithoutDefaults)));
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(_ref) {
      var guttersConfig = _ref.guttersConfig;
      var _ref$headerType = _ref.headerType;
      var headerType = _ref$headerType === undefined ? constants.headerType.DEFAULT : _ref$headerType;
      var height = _ref.height;
      var horizontalScrollConfig = _ref.horizontalScrollConfig;
      var nextList = _ref.list;
      var nextLists = _ref.lists;
      var _ref$scrollTo = _ref.scrollTo;
      var scrollToWithoutDefaults = _ref$scrollTo === undefined ? {} : _ref$scrollTo;
      var verticalScrollConfig = _ref.verticalScrollConfig;
      var width = _ref.width;
      var _props = this.props;
      var prevGuttersConfig = _props.guttersConfig;
      var prevHeight = _props.height;
      var prevHorizontalScrollConfig = _props.horizontalScrollConfig;
      var prevList = _props.list;
      var prevLists = _props.lists;
      var _props$scrollTo = _props.scrollTo;
      var prevScrollToWithoutDefaults = _props$scrollTo === undefined ? {} : _props$scrollTo;
      var prevVerticalScrollConfig = _props.verticalScrollConfig;
      var prevWidth = _props.width;
      var _state = this.state;
      var prevAvgRowHeight = _state.avgRowHeight;
      var oldCollapsedSections = _state.collapsedSections;
      var prevContentHeight = _state.contentHeight;


      var stackingHeaders = headerType === constants.headerType.STACKING;
      var prevListContainer = prevList || prevLists;
      var nextListContainer = nextList || nextLists;

      if (prevListContainer !== nextListContainer || !_lodash2.default.isEqual(prevListContainer, nextListContainer)) {
        var _buildRowConfig2 = (0, _utils.buildRowConfig)(nextListContainer, stackingHeaders, oldCollapsedSections);

        var avgRowHeight = _buildRowConfig2.avgRowHeight;
        var collapsedSections = _buildRowConfig2.collapsedSections;
        var contentHeight = _buildRowConfig2.contentHeight;
        var headers = _buildRowConfig2.headers;
        var partitions = _buildRowConfig2.partitions;
        var rowOffsets = _buildRowConfig2.rowOffsets;
        var rows = _buildRowConfig2.rows;

        this.setState(_extends({
          avgRowHeight: avgRowHeight,
          collapsedSections: collapsedSections,
          contentHeight: contentHeight,
          headers: headers,
          partitions: partitions,
          rowOffsets: rowOffsets,
          rows: rows
        }, this._getDimensions(avgRowHeight, contentHeight, height, width)));
      } else if (height !== prevHeight || width !== prevWidth || !_lodash2.default.isEqual(prevGuttersConfig, guttersConfig) || !_lodash2.default.isEqual(prevHorizontalScrollConfig, horizontalScrollConfig) || !_lodash2.default.isEqual(prevVerticalScrollConfig, verticalScrollConfig)) {
        this.setState(this._getDimensions(prevAvgRowHeight, prevContentHeight, height, width));
      }

      var prevScrollTo = _lodash2.default.merge(_lodash2.default.cloneDeep(constants.defaultScrollTo), _lodash2.default.cloneDeep(prevScrollToWithoutDefaults));
      var scrollTo = _lodash2.default.merge(_lodash2.default.cloneDeep(constants.defaultScrollTo), _lodash2.default.cloneDeep(scrollToWithoutDefaults));

      if (!_lodash2.default.isEqual(prevScrollTo, scrollTo)) {
        this._switchScrollProp(scrollTo);
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !_lodash2.default.isEqual(this.props, nextProps) || !_lodash2.default.isEqual(this.state, nextState);
    }

    // private

  }, {
    key: '_applyScrollChange',
    value: function _applyScrollChange(_ref2) {
      var _this2 = this;

      var _deltaX = _ref2.deltaX;
      var _deltaY = _ref2.deltaY;
      var _props2 = this.props;
      var _props2$disableBidire = _props2.disableBidirectionalScrolling;
      var disableBidirectionalScrolling = _props2$disableBidire === undefined ? false : _props2$disableBidire;
      var height = _props2.height;
      var horizontalScrollConfig = _props2.horizontalScrollConfig;
      var _props2$horizontalScr = _props2.horizontalScrollConfig;
      _props2$horizontalScr = _props2$horizontalScr === undefined ? {} : _props2$horizontalScr;
      var _props2$horizontalScr2 = _props2$horizontalScr.onScroll;
      var onHorizontalScroll = _props2$horizontalScr2 === undefined ? function () {} : _props2$horizontalScr2;
      var _props2$verticalScrol = _props2.verticalScrollConfig;
      _props2$verticalScrol = _props2$verticalScrol === undefined ? {} : _props2$verticalScrol;
      var _props2$verticalScrol2 = _props2$verticalScrol.onScroll;
      var onVerticalScroll = _props2$verticalScrol2 === undefined ? function () {} : _props2$verticalScrol2;
      var _state2 = this.state;
      var contentHeight = _state2.contentHeight;
      var oldFastScrollTrip = _state2.isFastScrolling;
      var partitions = _state2.partitions;
      var shouldRender = _state2.shouldRender;
      var oldVelocityQueue = _state2.velocityQueue;
      var _horizontalScrollbar = this._horizontalScrollbar;
      var _verticalScrollbar = this._verticalScrollbar;

      var withHorizontalScrolling = !!horizontalScrollConfig && shouldRender.horizontalScrollbar;

      var deltaX = _deltaX;
      var deltaY = _deltaY;

      if (disableBidirectionalScrolling) {
        if (Math.abs(deltaX) > Math.abs(deltaY)) {
          deltaY = 0;
        } else {
          deltaX = 0;
        }
      }

      var scrollChanges = {
        isScrolling: true
      };

      // vertical
      if (shouldRender.verticalScrollbar) {
        var maxHeight = (0, _utils.getMaxHeight)(contentHeight, _verticalScrollbar.offsetHeight);
        var verticalTransform = this.state.verticalTransform + deltaY;

        var _getVelocityInfo = (0, _utils.getVelocityInfo)(deltaY, oldVelocityQueue);

        var averageVelocity = _getVelocityInfo.averageVelocity;
        var velocityQueue = _getVelocityInfo.velocityQueue;


        var isFastScrolling = oldFastScrollTrip || Math.abs(averageVelocity) > height * constants.USER_INITIATED_FAST_SCROLL_FACTOR;

        _lodash2.default.assign(scrollChanges, (0, _utils.getVerticalScrollValues)(verticalTransform, maxHeight, partitions), { isFastScrolling: isFastScrolling, velocityQueue: velocityQueue });
      }

      // horizontal scrolling
      if (withHorizontalScrolling) {
        scrollChanges.horizontalTransform = _lodash2.default.clamp(this.state.horizontalTransform + deltaX, 0, _horizontalScrollbar.scrollWidth - _horizontalScrollbar.offsetWidth);
      }

      this.setState(scrollChanges, function () {
        if (shouldRender.verticalScrollbar) {
          if (_verticalScrollbar.scrollTop !== scrollChanges.verticalTransform) {
            onVerticalScroll(scrollChanges.verticalTransform);
          }
          _verticalScrollbar.scrollTop = scrollChanges.verticalTransform;
        }

        if (withHorizontalScrolling) {
          if (_horizontalScrollbar.scrollLeft !== scrollChanges.horizontalTransform) {
            onHorizontalScroll(scrollChanges.horizontalTransform);
          }
          _horizontalScrollbar.scrollLeft = scrollChanges.horizontalTransform;
        }

        _this2._endScroll();
      });
    }
  }, {
    key: '_getBottomGutterHeight',
    value: function _getBottomGutterHeight() {
      var _props3 = this.props;
      var height = _props3.height;
      var _props3$headerType = _props3.headerType;
      var headerType = _props3$headerType === undefined ? constants.headerType.DEFAULT : _props3$headerType;
      var _props3$horizontalScr = _props3.horizontalScrollConfig;
      _props3$horizontalScr = _props3$horizontalScr === undefined ? {} : _props3$horizontalScr;
      var _props3$horizontalScr2 = _props3$horizontalScr.scrollbarHeight;
      var scrollbarHeight = _props3$horizontalScr2 === undefined ? constants.HORIZONTAL_SCROLLBAR_HEIGHT : _props3$horizontalScr2;
      var _state3 = this.state;
      var headers = _state3.headers;
      var shouldRender = _state3.shouldRender;
      var verticalTransform = _state3.verticalTransform;


      if (headerType !== constants.headerType.STACKING) {
        return 0;
      }

      var adjustedHeight = shouldRender.horizontalScrollbar ? height - scrollbarHeight : height;

      var slidingWindowOfGutterHeight = 0;
      var indexOfFirstFreeGutter = headers.length - _lodash2.default.findIndex(_lodash2.default.reverse(_lodash2.default.clone(headers)), function (_ref3) {
        var headerHeight = _ref3.height;
        var realOffset = _ref3.realOffset;

        var adjustedTransform = verticalTransform + adjustedHeight - slidingWindowOfGutterHeight;
        var gutterIsLocked = adjustedTransform < realOffset;
        if (gutterIsLocked) {
          slidingWindowOfGutterHeight = headerHeight;
        }
        return !gutterIsLocked;
      });

      return (0, _lodash2.default)(headers).slice(indexOfFirstFreeGutter).reduce(function (prevHeight, _ref4) {
        var headerHeight = _ref4.height;
        return prevHeight + headerHeight;
      }, 0);
    }
  }, {
    key: '_getTopGutterHeight',
    value: function _getTopGutterHeight() {
      var _props$headerType2 = this.props.headerType;
      var headerType = _props$headerType2 === undefined ? constants.headerType.DEFAULT : _props$headerType2;
      var _state4 = this.state;
      var headers = _state4.headers;
      var verticalTransform = _state4.verticalTransform;


      if (headerType === constants.headerType.DEFAULT) {
        return 0;
      }

      var findNextHeaderIndex = _lodash2.default.findIndex(headers, function (_ref5) {
        var lockPosition = _ref5.lockPosition;
        return lockPosition > verticalTransform;
      });
      var nextHeaderIndex = findNextHeaderIndex === -1 ? headers.length : findNextHeaderIndex;

      if (headerType === constants.headerType.LOCKING) {
        var header = headers[nextHeaderIndex - 1];
        return header.height;
      }

      return (0, _lodash2.default)(headers).slice(0, nextHeaderIndex).reduce(function (prevHeight, _ref6) {
        var height = _ref6.height;
        return prevHeight + height;
      }, 0);
    }
  }, {
    key: '_getContentWidth',
    value: function _getContentWidth() {
      var _props4 = this.props;
      var _props4$dynamicColumn = _props4.dynamicColumn;
      var dynamicColumn = _props4$dynamicColumn === undefined ? constants.columns.MIDDLE : _props4$dynamicColumn;
      var guttersConfig = _props4.guttersConfig;
      var _props4$guttersConfig = _props4.guttersConfig;
      _props4$guttersConfig = _props4$guttersConfig === undefined ? {} : _props4$guttersConfig;
      var left = _props4$guttersConfig.left;
      var _props4$guttersConfig2 = _props4$guttersConfig.left;
      _props4$guttersConfig2 = _props4$guttersConfig2 === undefined ? {} : _props4$guttersConfig2;
      var _props4$guttersConfig3 = _props4$guttersConfig2.handleWidth;
      var leftHandleWidth = _props4$guttersConfig3 === undefined ? constants.LEFT_HANDLE_WIDTH : _props4$guttersConfig3;
      var _props4$guttersConfig4 = _props4$guttersConfig2.position;
      var leftGutterPosition = _props4$guttersConfig4 === undefined ? 0 : _props4$guttersConfig4;
      var right = _props4$guttersConfig.right;
      var _props4$guttersConfig5 = _props4$guttersConfig.right;
      _props4$guttersConfig5 = _props4$guttersConfig5 === undefined ? {} : _props4$guttersConfig5;
      var _props4$guttersConfig6 = _props4$guttersConfig5.handleWidth;
      var rightHandleWidth = _props4$guttersConfig6 === undefined ? constants.RIGHT_HANDLE_WIDTH : _props4$guttersConfig6;
      var _props4$guttersConfig7 = _props4$guttersConfig5.position;
      var rightGutterPosition = _props4$guttersConfig7 === undefined ? 0 : _props4$guttersConfig7;
      var _props4$horizontalScr = _props4.horizontalScrollConfig;
      _props4$horizontalScr = _props4$horizontalScr === undefined ? {} : _props4$horizontalScr;
      var _props4$horizontalScr2 = _props4$horizontalScr.contentWidth;
      var contentWidth = _props4$horizontalScr2 === undefined ? 0 : _props4$horizontalScr2;
      var width = _props4.width;


      var leftGutterWidth = void 0;
      var rightGutterWidth = void 0;
      switch (guttersConfig ? dynamicColumn : constants.columns.MIDDLE) {
        case constants.columns.LEFT:
          leftGutterWidth = width - leftGutterPosition - leftHandleWidth;
          rightGutterWidth = rightGutterPosition;
          break;
        case constants.columns.RIGHT:
          leftGutterWidth = leftGutterPosition;
          rightGutterWidth = width - rightGutterPosition - rightHandleWidth;
          break;
        default:
          leftGutterWidth = leftGutterPosition;
          rightGutterWidth = rightGutterPosition;
      }

      return _lodash2.default.sum([contentWidth, leftGutterWidth, left ? leftHandleWidth : 0, right ? rightHandleWidth : 0, rightGutterWidth]);
    }
  }, {
    key: '_getDimensions',
    value: function _getDimensions(avgRowHeight, contentHeight, height, width) {
      var _ref7 = this.props.horizontalScrollConfig || {};

      var _ref7$scrollbarHeight = _ref7.scrollbarHeight;
      var scrollbarHeight = _ref7$scrollbarHeight === undefined ? constants.HORIZONTAL_SCROLLBAR_HEIGHT : _ref7$scrollbarHeight;

      var shouldRender = this._shouldRenderScrollbars(contentHeight, height, width);
      var contentsDivHeight = height - (shouldRender.horizontalScrollbar ? scrollbarHeight : 0);
      var numRowsInContents = _lodash2.default.ceil(contentsDivHeight / avgRowHeight);

      var displayBuffer = numRowsInContents + 2 * constants.OFFSET_BUFFER;
      displayBuffer += constants.OFFSET_BUFFER - displayBuffer % constants.OFFSET_BUFFER;

      var newState = {
        displayBuffer: displayBuffer,
        shouldRender: shouldRender
      };

      if (!shouldRender.verticalScrollbar) {
        newState.verticalTransform = 0;
        newState.topPartitionIndex = 0;
        if (this._verticalScrollbar) {
          this._verticalScrollbar.scrollTop = 0;
        }
      }

      if (!shouldRender.horizontalScrollbar) {
        newState.horizontalTransform = 0;
        if (this._horizontalScrollbar) {
          this._horizontalScrollbar.scrollLeft = 0;
        }
      }

      return newState;
    }
  }, {
    key: '_getThrottledAnimationFrameFn',
    value: function _getThrottledAnimationFrameFn(scrollTo) {
      var _this3 = this;

      var _props5 = this.props;
      var height = _props5.height;
      var _props5$horizontalScr = _props5.horizontalScrollConfig;
      _props5$horizontalScr = _props5$horizontalScr === undefined ? {} : _props5$horizontalScr;
      var _props5$horizontalScr2 = _props5$horizontalScr.onScroll;
      var onHorizontalScroll = _props5$horizontalScr2 === undefined ? function () {} : _props5$horizontalScr2;
      var _props5$verticalScrol = _props5.verticalScrollConfig;
      _props5$verticalScrol = _props5$verticalScrol === undefined ? {} : _props5$verticalScrol;
      var _props5$verticalScrol2 = _props5$verticalScrol.onScroll;
      var onVerticalScroll = _props5$verticalScrol2 === undefined ? function () {} : _props5$verticalScrol2;
      var _state5 = this.state;
      var horizontalTransform = _state5.horizontalTransform;
      var verticalTransform = _state5.verticalTransform;

      var delta = _lodash2.default.clone(scrollTo).sub(new _models.Point(horizontalTransform, verticalTransform));

      var initStateUpdate = {
        scrolling: true
      };

      if (Math.abs(delta.y) > height * constants.SCROLL_TO_FAST_SCROLL_FACTOR) {
        initStateUpdate.isFastScrolling = true;
      }

      this.setState(initStateUpdate);

      return _lodash2.default.throttle(easer(function (easedElapsedTime) {
        var horizontalScrollConfig = _this3.props.horizontalScrollConfig;
        var _state6 = _this3.state;
        var contentHeight = _state6.contentHeight;
        var partitions = _state6.partitions;
        var latestScrollingToPosition = _state6.scrollingToPosition;
        var shouldRender = _state6.shouldRender;
        var _horizontalScrollbar = _this3._horizontalScrollbar;
        var _verticalScrollbar = _this3._verticalScrollbar;

        if (!_lodash2.default.isEqual(scrollTo, latestScrollingToPosition)) {
          return;
        }

        var withHorizontalScrolling = !!horizontalScrollConfig && shouldRender.horizontalScrollbar;
        var elapsedTime = easedElapsedTime > 0.999 ? 1 : easedElapsedTime;
        var deltaScrolled = new _models.Point(delta.x, delta.y).scale(elapsedTime);
        var newTransform = new _models.Point(horizontalTransform, verticalTransform).add(deltaScrolled);

        var scrollChanges = {
          isScrolling: true
        };

        // vertical
        if (shouldRender.verticalScrollbar) {
          var maxHeight = (0, _utils.getMaxHeight)(contentHeight, _verticalScrollbar.offsetHeight);
          _lodash2.default.assign(scrollChanges, (0, _utils.getVerticalScrollValues)(newTransform.y, maxHeight, partitions));
        }

        // horizontal scrolling
        if (withHorizontalScrolling) {
          scrollChanges.horizontalTransform = _lodash2.default.clamp(newTransform.x, 0, _horizontalScrollbar.scrollWidth - _horizontalScrollbar.offsetWidth);
        }

        _this3.setState(scrollChanges, function () {
          if (shouldRender.verticalScrollbar) {
            if (_verticalScrollbar.scrollTop !== scrollChanges.verticalTransform) {
              onVerticalScroll(scrollChanges.verticalTransform);
            }
            _verticalScrollbar.scrollTop = scrollChanges.verticalTransform;
          }

          if (withHorizontalScrolling) {
            if (_horizontalScrollbar.scrollLeft !== scrollChanges.horizontalTransform) {
              onHorizontalScroll(scrollChanges.horizontalTransform);
            }
            _horizontalScrollbar.scrollLeft = scrollChanges.horizontalTransform;
          }

          _this3._endScroll();
        });
      }), constants.ANIMATION_FPS_120, { leading: true });
    }
  }, {
    key: '_getWeightedWidth',
    value: function _getWeightedWidth() {
      var _props6 = this.props;
      var _props6$verticalScrol = _props6.verticalScrollConfig;
      _props6$verticalScrol = _props6$verticalScrol === undefined ? {} : _props6$verticalScrol;
      var _props6$verticalScrol2 = _props6$verticalScrol.scrollbarWidth;
      var scrollbarWidth = _props6$verticalScrol2 === undefined ? constants.VERTICAL_SCROLLBAR_WIDTH : _props6$verticalScrol2;
      var width = _props6.width;
      var shouldRender = this.state.shouldRender;


      return width - (shouldRender.verticalScrollbar ? scrollbarWidth : 0);
    }
  }, {
    key: '_onHorizontalScroll',
    value: function _onHorizontalScroll() {
      var _props$horizontalScro = this.props.horizontalScrollConfig;
      _props$horizontalScro = _props$horizontalScro === undefined ? {} : _props$horizontalScro;
      var _props$horizontalScro2 = _props$horizontalScro.onScroll;
      var onScroll = _props$horizontalScro2 === undefined ? function () {} : _props$horizontalScro2;
      var horizontalTransform = this.state.horizontalTransform;
      var _horizontalScrollbar = this._horizontalScrollbar;


      if (!_horizontalScrollbar || _horizontalScrollbar.scrollLeft === horizontalTransform) {
        return;
      }

      var _ref8 = _horizontalScrollbar || {};

      var _ref8$scrollLeft = _ref8.scrollLeft;
      var scrollLeft = _ref8$scrollLeft === undefined ? 0 : _ref8$scrollLeft;

      this.setState({ horizontalTransform: scrollLeft });
      onScroll(scrollLeft);
    }
  }, {
    key: '_onMouseWheel',
    value: function _onMouseWheel(_ref9) {
      var deltaX = _ref9.deltaX;
      var deltaY = _ref9.deltaY;

      this._onThrottledMouseWheel({ deltaX: deltaX, deltaY: deltaY });
    }

    /**
     * Performs a calculation to determine the size difference between each movement of the mouse cursor. Only occurs when
     * a resize is active. Will call the onResize handler for the gutter that is being resized with the new width of the
     * gutter.
     * @param  {number} clientX the position of the mouse cursor horizontally
     */

  }, {
    key: '_onResize',
    value: function _onResize(_ref10) {
      var clientX = _ref10.clientX;
      var _state$resize = this.state.resize;
      var basePosition = _state$resize.basePosition;
      var performing = _state$resize.performing;
      var side = _state$resize.side;
      var startingPosition = _state$resize.startingPosition;

      var width = this._getWeightedWidth();
      var _props7 = this.props;
      var _props7$dynamicColumn = _props7.dynamicColumn;
      var dynamicColumn = _props7$dynamicColumn === undefined ? constants.columns.MIDDLE : _props7$dynamicColumn;
      var guttersConfig = _props7.guttersConfig;
      var _props7$guttersConfig = _props7.guttersConfig;
      _props7$guttersConfig = _props7$guttersConfig === undefined ? {} : _props7$guttersConfig;
      var left = _props7$guttersConfig.left;
      var _props7$guttersConfig2 = _props7$guttersConfig.left;
      _props7$guttersConfig2 = _props7$guttersConfig2 === undefined ? {} : _props7$guttersConfig2;
      var _props7$guttersConfig3 = _props7$guttersConfig2.handleWidth;
      var leftHandleWidth = _props7$guttersConfig3 === undefined ? constants.LEFT_HANDLE_WIDTH : _props7$guttersConfig3;
      var leftHandlePosition = _props7$guttersConfig2.position;
      var right = _props7$guttersConfig.right;
      var _props7$guttersConfig4 = _props7$guttersConfig.right;
      _props7$guttersConfig4 = _props7$guttersConfig4 === undefined ? {} : _props7$guttersConfig4;
      var _props7$guttersConfig5 = _props7$guttersConfig4.handleWidth;
      var rightHandleWidth = _props7$guttersConfig5 === undefined ? constants.RIGHT_HANDLE_WIDTH : _props7$guttersConfig5;
      var rightHandlePosition = _props7$guttersConfig4.position;
      var _props7$guttersConfig6 = _props7$guttersConfig[side];
      _props7$guttersConfig6 = _props7$guttersConfig6 === undefined ? {} : _props7$guttersConfig6;
      var _props7$guttersConfig7 = _props7$guttersConfig6.minPosition;
      var minPosition = _props7$guttersConfig7 === undefined ? 0 : _props7$guttersConfig7;
      var _props7$guttersConfig8 = _props7$guttersConfig6.maxPosition;
      var maxPosition = _props7$guttersConfig8 === undefined ? width : _props7$guttersConfig8;
      var _props7$guttersConfig9 = _props7$guttersConfig6.onResize;
      var onResize = _props7$guttersConfig9 === undefined ? function () {} : _props7$guttersConfig9;

      if (performing) {
        var deltaPosition = startingPosition - clientX;

        var _getResizeValues = (0, _utils.getResizeValues)({
          dynamicColumn: guttersConfig ? dynamicColumn : constants.columns.MIDDLE,
          leftExists: Boolean(left),
          leftHandlePosition: leftHandlePosition,
          leftHandleWidth: leftHandleWidth,
          rightExists: Boolean(right),
          rightHandlePosition: rightHandlePosition,
          rightHandleWidth: rightHandleWidth,
          side: side,
          width: width
        });

        var max = _getResizeValues.max;
        var min = _getResizeValues.min;
        var mod = _getResizeValues.mod;


        onResize(_lodash2.default.clamp(basePosition + mod * deltaPosition, Math.max(minPosition, min), Math.min(maxPosition, max)));
      }
    }
  }, {
    key: '_onVerticalScroll',
    value: function _onVerticalScroll() {
      var _this4 = this;

      var _props8 = this.props;
      var height = _props8.height;
      var _props8$verticalScrol = _props8.verticalScrollConfig;
      _props8$verticalScrol = _props8$verticalScrol === undefined ? {} : _props8$verticalScrol;
      var _props8$verticalScrol2 = _props8$verticalScrol.onScroll;
      var onScroll = _props8$verticalScrol2 === undefined ? function () {} : _props8$verticalScrol2;
      var _state7 = this.state;
      var contentHeight = _state7.contentHeight;
      var wasFastScrolling = _state7.isFastScrolling;
      var partitions = _state7.partitions;
      var oldVelocityQueue = _state7.velocityQueue;
      var verticalTransform = _state7.verticalTransform;
      var _verticalScrollbar = this._verticalScrollbar;
      var _verticalScrollbar2 = this._verticalScrollbar;
      _verticalScrollbar2 = _verticalScrollbar2 === undefined ? {} : _verticalScrollbar2;
      var offsetHeight = _verticalScrollbar2.offsetHeight;
      var scrollTop = _verticalScrollbar2.scrollTop;


      if (!_verticalScrollbar || scrollTop === verticalTransform) {
        return;
      }

      var maxHeight = (0, _utils.getMaxHeight)(contentHeight, offsetHeight);

      var nextScrollState = (0, _utils.getVerticalScrollValues)(scrollTop, maxHeight, partitions);

      var _getVelocityInfo2 = (0, _utils.getVelocityInfo)(nextScrollState.verticalTransform - verticalTransform, oldVelocityQueue);

      var averageVelocity = _getVelocityInfo2.averageVelocity;
      var velocityQueue = _getVelocityInfo2.velocityQueue;

      var isFastScrolling = wasFastScrolling || Math.abs(averageVelocity) > height * 3 / 4;

      this.setState(_lodash2.default.assign(nextScrollState, {
        averageVelocity: averageVelocity,
        isFastScrolling: isFastScrolling,
        isScrolling: true,
        velocityQueue: velocityQueue
      }), function () {
        return _this4._endScroll();
      });
      onScroll(nextScrollState.verticalTransform);
    }
  }, {
    key: '_renderContents',
    value: function _renderContents() {
      var _this5 = this;

      var _props9 = this.props;
      var _props9$dynamicColumn = _props9.dynamicColumn;
      var dynamicColumn = _props9$dynamicColumn === undefined ? constants.columns.MIDDLE : _props9$dynamicColumn;
      var guttersConfig = _props9.guttersConfig;
      var _props9$horizontalScr = _props9.horizontalScrollConfig;
      _props9$horizontalScr = _props9$horizontalScr === undefined ? {} : _props9$horizontalScr;
      var _props9$horizontalScr2 = _props9$horizontalScr.passthroughOffsets;
      var passthroughOffsets = _props9$horizontalScr2 === undefined ? false : _props9$horizontalScr2;
      var _props9$light = _props9.light;
      var light = _props9$light === undefined ? false : _props9$light;
      var _props9$verticalScrol = _props9.verticalScrollConfig;
      _props9$verticalScrol = _props9$verticalScrol === undefined ? {} : _props9$verticalScrol;
      var _props9$verticalScrol2 = _props9$verticalScrol.scrollbarWidth;
      var scrollbarWidth = _props9$verticalScrol2 === undefined ? constants.VERTICAL_SCROLLBAR_WIDTH : _props9$verticalScrol2;
      var _state8 = this.state;
      var displayBuffer = _state8.displayBuffer;
      var isFastScrolling = _state8.isFastScrolling;
      var horizontalTransform = _state8.horizontalTransform;
      var partitions = _state8.partitions;
      var rows = _state8.rows;
      var isScrolling = _state8.isScrolling;
      var shouldRender = _state8.shouldRender;
      var topPartitionIndex = _state8.topPartitionIndex;
      var verticalTransform = _state8.verticalTransform;


      var contentsStyle = shouldRender.verticalScrollbar ? {
        width: 'calc(100% - ' + scrollbarWidth + 'px)'
      } : undefined;

      var weightedPartitionIndex = topPartitionIndex * constants.OFFSET_BUFFER;
      var startingRowIndex = Math.min(weightedPartitionIndex, rows.length);
      var endingRowIndex = weightedPartitionIndex + displayBuffer;
      var weightedWidth = this._getWeightedWidth();

      var rowsWeWillRender = _lodash2.default.slice(rows, startingRowIndex, endingRowIndex);
      var partitionedRows = _lodash2.default.chunk(rowsWeWillRender, constants.OFFSET_BUFFER);
      var renderedPartitions = _lodash2.default.map(partitionedRows, function (row, outerIndex) {
        var partitionIndex = outerIndex + topPartitionIndex;
        var basePartitionOffset = partitions[partitionIndex];
        var partitionStyle = {
          transform: 'translate3d(-0px, ' + (basePartitionOffset - verticalTransform) + 'px, 0px)'
        };

        return _react2.default.createElement(
          'div',
          { className: 'rickscroll__partition', key: partitionIndex, style: partitionStyle },
          _lodash2.default.map(row, function (_ref11, innerIndex) {
            var className = _ref11.className;
            var contentComponent = _ref11.contentComponent;
            var contentClassName = _ref11.contentClassName;
            var gutters = _ref11.gutters;
            var height = _ref11.height;
            var isHeader = _ref11.isHeader;
            var key = _ref11.key;
            var rowProps = _ref11.props;
            return light ? _react2.default.createElement(_LightweightRow2.default, {
              className: className,
              contentClassName: contentClassName,
              contentComponent: contentComponent,
              horizontalTransform: horizontalTransform,
              isFastScrolling: isScrolling && isFastScrolling,
              isHeader: isHeader,
              key: key || innerIndex,
              passthroughOffsets: passthroughOffsets,
              rowHeight: height,
              rowProps: rowProps,
              width: weightedWidth
            }) : _react2.default.createElement(_Row2.default, {
              className: className,
              contentClassName: contentClassName,
              contentComponent: contentComponent,
              dynamicColumn: dynamicColumn,
              gutters: gutters,
              guttersConfig: guttersConfig,
              horizontalTransform: horizontalTransform,
              index: innerIndex,
              isFastScrolling: isScrolling && isFastScrolling,
              isHeader: isHeader,
              key: key || innerIndex,
              onStartResize: _this5._startResize,
              passthroughOffsets: passthroughOffsets,
              rowHeight: height,
              rowProps: rowProps,
              width: weightedWidth
            });
          })
        );
      });

      var _renderHeader2 = this._renderHeader();

      var bottomHeaderGutter = _renderHeader2.bottomHeaderGutter;
      var header = _renderHeader2.header;
      var topHeaderGutter = _renderHeader2.topHeaderGutter;

      // TODO remove partitions and shift the contents of the div

      return _react2.default.createElement(
        'div',
        { className: 'rickscroll__contents', key: 'contents', style: contentsStyle },
        header,
        topHeaderGutter,
        renderedPartitions,
        bottomHeaderGutter
      );
    }
  }, {
    key: '_renderCorner',
    value: function _renderCorner() {
      var _props10 = this.props;
      var horizontalScrollConfig = _props10.horizontalScrollConfig;
      var _props10$horizontalSc = _props10.horizontalScrollConfig;
      _props10$horizontalSc = _props10$horizontalSc === undefined ? {} : _props10$horizontalSc;
      var _props10$horizontalSc2 = _props10$horizontalSc.scrollbarHeight;
      var scrollbarHeight = _props10$horizontalSc2 === undefined ? constants.HORIZONTAL_SCROLLBAR_HEIGHT : _props10$horizontalSc2;
      var _props10$verticalScro = _props10.verticalScrollConfig;
      _props10$verticalScro = _props10$verticalScro === undefined ? {} : _props10$verticalScro;
      var _props10$verticalScro2 = _props10$verticalScro.scrollbarWidth;
      var scrollbarWidth = _props10$verticalScro2 === undefined ? constants.VERTICAL_SCROLLBAR_WIDTH : _props10$verticalScro2;
      var shouldRender = this.state.shouldRender;


      var shouldRenderCorner = !!horizontalScrollConfig && shouldRender.verticalScrollbar;

      if (!shouldRenderCorner) {
        return null;
      }

      var cornerStyle = {
        height: scrollbarHeight + 'px',
        width: scrollbarWidth + 'px'
      };

      return _react2.default.createElement('div', { className: 'rickscroll__corner', style: cornerStyle });
    }
  }, {
    key: '_renderHeader',
    value: function _renderHeader() {
      var _props11 = this.props;
      var _props11$dynamicColum = _props11.dynamicColumn;
      var dynamicColumn = _props11$dynamicColum === undefined ? constants.columns.MIDDLE : _props11$dynamicColum;
      var guttersConfig = _props11.guttersConfig;
      var _props11$headerType = _props11.headerType;
      var headerType = _props11$headerType === undefined ? constants.headerType.DEFAULT : _props11$headerType;
      var height = _props11.height;
      var _props11$horizontalSc = _props11.horizontalScrollConfig;
      _props11$horizontalSc = _props11$horizontalSc === undefined ? {} : _props11$horizontalSc;
      var _props11$horizontalSc2 = _props11$horizontalSc.scrollbarHeight;
      var scrollbarHeight = _props11$horizontalSc2 === undefined ? constants.HORIZONTAL_SCROLLBAR_HEIGHT : _props11$horizontalSc2;
      var _state9 = this.state;
      var headers = _state9.headers;
      var rows = _state9.rows;
      var shouldRender = _state9.shouldRender;
      var verticalTransform = _state9.verticalTransform;


      if (!headers || headers.length === 0) {
        return {};
      }

      var maxLockPosition = headers[headers.length - 1].lockPosition;

      var findNextHeaderIndex = _lodash2.default.findIndex(headers, function (_ref12) {
        var lockPosition = _ref12.lockPosition;
        return lockPosition > verticalTransform;
      });
      var nextHeaderIndex = findNextHeaderIndex === -1 ? headers.length : findNextHeaderIndex;
      var weightedWidth = this._getWeightedWidth();

      if (headerType === constants.headerType.STACKING) {
        var _ret = function () {
          var topHeaderGutter = _react2.default.createElement(
            'div',
            { className: 'rickscroll__header-gutter rickscroll__header-gutter--top', key: 'top-header-gutter' },
            _lodash2.default.times(nextHeaderIndex, function (headerIndex) {
              var headerRowIndex = headers[headerIndex].index;
              var _rows$headerRowIndex = rows[headerRowIndex];
              var className = _rows$headerRowIndex.className;
              var contentComponent = _rows$headerRowIndex.contentComponent;
              var rowHeight = _rows$headerRowIndex.height;
              var key = _rows$headerRowIndex.key;
              var rowProps = _rows$headerRowIndex.props;


              return _react2.default.createElement(_Row2.default, {
                className: className,
                contentComponent: contentComponent,
                dynamicColumn: dynamicColumn,
                guttersConfig: guttersConfig,
                horizontalTransform: 0,
                index: headerRowIndex,
                key: key || headerIndex,
                rowHeight: rowHeight,
                rowProps: rowProps,
                width: weightedWidth
              });
            })
          );

          var bottomGutterStartIndex = nextHeaderIndex;
          /* We want to erase headers as they come into view in the contents view from the header gutter
           * We solve for the vertical transform that we need to remove a header from the bottom gutter:
           * height: height of the header we are transitioning
           * topHeight: height of all other gutters pinned to the top, not including baseHeight
           * realOffset: the verticalTransform that aligns the next header with the top of the rickscroll__contents
           * bottomHeight: the height of the bottom gutter of combined headers
           * adjustedBottomHeight: the total height of the headers in the bottom gutter with the baseHeight
           * adjustedTransform: the vertical transform that is adjusted to the scale of viewable contents
           * ------------------------------------------------------------------------------------------------------------
           * we should delete the top header from the bottom gutter if the adjusted transform is smaller than the
           * height of contents window
           */
          var contentsDivHeight = height - (shouldRender.horizontalScrollbar ? scrollbarHeight : 0);
          var baseHeight = headers[0].height;

          var _ref13 = headers[nextHeaderIndex] || headers[nextHeaderIndex - 1];

          var topHeight = _ref13.adjustHeaderOffset;
          var removeFirstHeaderOffset = _ref13.realOffset;
          var bottomHeight = headers[headers.length - 1].adjustHeaderOffset;

          var adjustedBottomHeight = baseHeight + bottomHeight - topHeight;
          var adjustedTransform = removeFirstHeaderOffset - verticalTransform + adjustedBottomHeight;
          if (bottomGutterStartIndex !== headers.length && adjustedTransform <= contentsDivHeight - 1) {
            bottomGutterStartIndex++;
            var skipHeadersUntil = (0, _lodash2.default)(headers).slice(bottomGutterStartIndex).findIndex(function (_ref14) {
              var adjustHeaderOffset = _ref14.adjustHeaderOffset;
              var realOffset = _ref14.realOffset;

              var restHeight = bottomHeight - adjustHeaderOffset;
              return realOffset + topHeight >= contentsDivHeight + verticalTransform - restHeight;
            });

            if (skipHeadersUntil >= 0) {
              bottomGutterStartIndex += skipHeadersUntil;
            } else {
              bottomGutterStartIndex = headers.length;
            }
          }

          var bottomHeaderGutter = _react2.default.createElement(
            'div',
            { className: 'rickscroll__header-gutter rickscroll__header-gutter--bottom', key: 'bottom-header-gutter' },
            (0, _lodash2.default)(headers).slice(bottomGutterStartIndex).map(function (_ref15, index) {
              var headerRowIndex = _ref15.index;
              var lockPosition = _ref15.lockPosition;

              var headerIndex = bottomGutterStartIndex + index;
              var _rows$headerRowIndex2 = rows[headerRowIndex];
              var className = _rows$headerRowIndex2.className;
              var contentComponent = _rows$headerRowIndex2.contentComponent;
              var rowHeight = _rows$headerRowIndex2.height;
              var key = _rows$headerRowIndex2.key;
              var rowProps = _rows$headerRowIndex2.props;


              return _react2.default.createElement(_Row2.default, {
                className: className,
                contentComponent: contentComponent,
                dynamicColumn: dynamicColumn,
                guttersConfig: guttersConfig,
                horizontalTransform: 0,
                index: headerRowIndex,
                key: key || headerIndex,
                rowHeight: rowHeight,
                rowProps: rowProps,
                width: weightedWidth
              });
            }).value()
          );

          return {
            v: { bottomHeaderGutter: bottomHeaderGutter, topHeaderGutter: topHeaderGutter }
          };
        }();

        if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
      } else if (headerType === constants.headerType.LOCKING) {
        var headerIndex = nextHeaderIndex - 1;

        var _ref16 = headers[nextHeaderIndex] || headers[headerIndex];

        var lockPosition = _ref16.lockPosition;
        var headerRowIndex = headers[headerIndex].index;
        var _rows$headerRowIndex3 = rows[headerRowIndex];
        var className = _rows$headerRowIndex3.className;
        var contentComponent = _rows$headerRowIndex3.contentComponent;
        var rowHeight = _rows$headerRowIndex3.height;
        var key = _rows$headerRowIndex3.key;
        var rowProps = _rows$headerRowIndex3.props;


        var headerStyle = {
          height: rowHeight + 'px',
          transform: 'translate3d(0px, 0px, 0px)'
        };

        if (verticalTransform < maxLockPosition && verticalTransform >= lockPosition - rowHeight) {
          var overlap = lockPosition - verticalTransform;
          var headerOffset = rowHeight - overlap;
          headerStyle.transform = 'translate3d(0px, -' + headerOffset + 'px, 0px)';
        }

        var header = _react2.default.createElement(
          'div',
          { className: 'rickscroll__header', key: 'header-' + headerRowIndex, style: headerStyle },
          _react2.default.createElement(_Row2.default, {
            className: className,
            contentComponent: contentComponent,
            dynamicColumn: dynamicColumn,
            guttersConfig: guttersConfig,
            horizontalTransform: 0,
            index: headerRowIndex,
            key: key || headerRowIndex,
            rowHeight: rowHeight,
            rowProps: rowProps,
            width: weightedWidth
          })
        );

        return { header: header };
      }

      return {};
    }

    /**
     * Decides whether or not to render the horizontal scroll bar
     * @return null or a container with horizontal scrollbar and maybe the corner piece
     */

  }, {
    key: '_renderHorizontalScrollbar',
    value: function _renderHorizontalScrollbar() {
      var _this6 = this;

      var _props12 = this.props;
      var _props12$dynamicColum = _props12.dynamicColumn;
      var dynamicColumn = _props12$dynamicColum === undefined ? constants.columns.MIDDLE : _props12$dynamicColum;
      var guttersConfig = _props12.guttersConfig;
      var _props12$guttersConfi = _props12.guttersConfig;
      _props12$guttersConfi = _props12$guttersConfi === undefined ? {} : _props12$guttersConfi;
      var left = _props12$guttersConfi.left;
      var _props12$guttersConfi2 = _props12$guttersConfi.left;
      _props12$guttersConfi2 = _props12$guttersConfi2 === undefined ? {} : _props12$guttersConfi2;
      var _props12$guttersConfi3 = _props12$guttersConfi2.handleWidth;
      var leftHandleWidth = _props12$guttersConfi3 === undefined ? constants.LEFT_HANDLE_WIDTH : _props12$guttersConfi3;
      var leftHandlePosition = _props12$guttersConfi2.position;
      var right = _props12$guttersConfi.right;
      var _props12$guttersConfi4 = _props12$guttersConfi.right;
      _props12$guttersConfi4 = _props12$guttersConfi4 === undefined ? {} : _props12$guttersConfi4;
      var _props12$guttersConfi5 = _props12$guttersConfi4.handleWidth;
      var rightHandleWidth = _props12$guttersConfi5 === undefined ? constants.RIGHT_HANDLE_WIDTH : _props12$guttersConfi5;
      var rightHandlePosition = _props12$guttersConfi4.position;
      var horizontalScrollConfig = _props12.horizontalScrollConfig;
      var _props12$horizontalSc = _props12.horizontalScrollConfig;
      _props12$horizontalSc = _props12$horizontalSc === undefined ? {} : _props12$horizontalSc;
      var className = _props12$horizontalSc.className;
      var _props12$horizontalSc2 = _props12$horizontalSc.scaleWithCenterContent;
      var scaleWithCenterContent = _props12$horizontalSc2 === undefined ? false : _props12$horizontalSc2;
      var _props12$horizontalSc3 = _props12$horizontalSc.scrollbarHeight;
      var scrollbarHeight = _props12$horizontalSc3 === undefined ? constants.HORIZONTAL_SCROLLBAR_HEIGHT : _props12$horizontalSc3;
      var _props12$verticalScro = _props12.verticalScrollConfig;
      _props12$verticalScro = _props12$verticalScro === undefined ? {} : _props12$verticalScro;
      var _props12$verticalScro2 = _props12$verticalScro.scrollbarWidth;
      var scrollbarWidth = _props12$verticalScro2 === undefined ? constants.VERTICAL_SCROLLBAR_WIDTH : _props12$verticalScro2;
      var shouldRender = this.state.shouldRender;


      var withHorizontalScrolling = !!horizontalScrollConfig && shouldRender.horizontalScrollbar;

      if (!withHorizontalScrolling) {
        return null;
      }

      // TODO fix scaleWithCenterContent
      var contentWidth = this._getContentWidth();

      var _getGutterWidths = (0, _utils.getGutterWidths)({
        dynamicColumn: guttersConfig ? dynamicColumn : constants.columns.MIDDLE,
        leftHandlePosition: leftHandlePosition,
        leftHandleWidth: leftHandleWidth,
        rightHandlePosition: rightHandlePosition,
        rightHandleWidth: rightHandleWidth,
        width: this._getWeightedWidth()
      });

      var leftGutterWidth = _getGutterWidths.leftGutterWidth;
      var rightGutterWidth = _getGutterWidths.rightGutterWidth;

      var shouldRenderCorner = !!horizontalScrollConfig && shouldRender.verticalScrollbar;
      var cornerWidth = (0, _utils.returnWidthIfComponentExists)(scrollbarWidth, shouldRenderCorner);
      var adjustedContentWidth = contentWidth - cornerWidth;
      var leftWidth = void 0;
      var position = void 0;
      var scaledWidth = void 0;

      // If the scale with center content flag is enabled, we will adjust the scrollbar to be in the correct position
      // and set up the width to be equivelant to the center content
      // we will also have to adjust the size of the filler content by the gutters
      if (scaleWithCenterContent) {
        var rightWidth = (0, _utils.returnWidthIfComponentExists)(rightHandleWidth + rightGutterWidth, right);

        leftWidth = (0, _utils.returnWidthIfComponentExists)(leftHandleWidth + leftGutterWidth, left);
        adjustedContentWidth -= leftWidth + rightWidth;
        position = 'relative';
        scaledWidth = 'calc(100% - ' + leftWidth + 'px - ' + rightWidth + 'px - ' + cornerWidth + 'px)';
      }

      var wrapperStyle = {
        height: scrollbarHeight + 'px'
      };

      var scrollBarDivStyle = {
        height: scrollbarHeight + 'px',
        left: leftWidth,
        position: position,
        width: scaledWidth
      };

      var fillerStyle = { height: '1px', width: adjustedContentWidth + 'px' };

      var getHorizontalScrollbarRef = function getHorizontalScrollbarRef(r) {
        _this6._horizontalScrollbar = r;
      };
      var horizontalScrollbarClassName = (0, _classnames2.default)('rickscroll__horizontal-scrollbar', className);

      return _react2.default.createElement(
        'div',
        { className: 'rickscroll__bottom-wrapper', style: wrapperStyle },
        _react2.default.createElement(
          'div',
          {
            className: horizontalScrollbarClassName,
            key: 'scrollable',
            onScroll: this._onHorizontalScroll,
            ref: getHorizontalScrollbarRef,
            style: scrollBarDivStyle
          },
          _react2.default.createElement('div', { style: fillerStyle }),
          ' '
        ),
        this._renderCorner()
      );
    }

    /**
     * Decides whether or not to render the vertical scroll bar
     * @return null or a container with vertical scrollbar
     */

  }, {
    key: '_renderVerticalScrollbar',
    value: function _renderVerticalScrollbar() {
      var _this7 = this;

      var _props$verticalScroll = this.props.verticalScrollConfig;
      _props$verticalScroll = _props$verticalScroll === undefined ? {} : _props$verticalScroll;
      var className = _props$verticalScroll.className;
      var _props$verticalScroll2 = _props$verticalScroll.scrollbarWidth;
      var scrollbarWidth = _props$verticalScroll2 === undefined ? constants.VERTICAL_SCROLLBAR_WIDTH : _props$verticalScroll2;
      var _state10 = this.state;
      var contentHeight = _state10.contentHeight;
      var shouldRender = _state10.shouldRender;


      if (!shouldRender.verticalScrollbar) {
        return null;
      }

      var fillerStyle = {
        height: contentHeight + 'px',
        width: '1px'
      };
      var verticalScrollbarStyle = {
        minWidth: scrollbarWidth + 'px'
      };

      var getVerticalScrollbarRef = function getVerticalScrollbarRef(r) {
        _this7._verticalScrollbar = r;
      };
      var verticalScrollbarCassName = (0, _classnames2.default)('rickscroll__vertical-scrollbar', className);
      return _react2.default.createElement(
        'div',
        {
          className: verticalScrollbarCassName,
          onScroll: this._onVerticalScroll,
          ref: getVerticalScrollbarRef,
          style: verticalScrollbarStyle
        },
        _react2.default.createElement('div', { style: fillerStyle }),
        ' '
      );
    }

    /**
     * Decides which scrollbars should be showing based off of the dimensions of the content and rickscroll container.
     * @return { horizontalScrollbar, verticalScrollbar } a pair of booleans that tell rickscroll whether or not to render
     *                                                    the horizontal and vertical scrollbars
     */

  }, {
    key: '_shouldRenderScrollbars',
    value: function _shouldRenderScrollbars(contentHeight, height, width) {
      var _props13 = this.props;
      var _props13$horizontalSc = _props13.horizontalScrollConfig;
      _props13$horizontalSc = _props13$horizontalSc === undefined ? {} : _props13$horizontalSc;
      var _props13$horizontalSc2 = _props13$horizontalSc.scrollbarHeight;
      var scrollbarHeight = _props13$horizontalSc2 === undefined ? constants.HORIZONTAL_SCROLLBAR_HEIGHT : _props13$horizontalSc2;
      var _props13$verticalScro = _props13.verticalScrollConfig;
      _props13$verticalScro = _props13$verticalScro === undefined ? {} : _props13$verticalScro;
      var _props13$verticalScro2 = _props13$verticalScro.scrollbarWidth;
      var scrollbarWidth = _props13$verticalScro2 === undefined ? constants.VERTICAL_SCROLLBAR_WIDTH : _props13$verticalScro2;


      var clientHeightTooSmall = height < contentHeight;
      var clientHeightTooSmallWithHorizontalScrollbar = height < contentHeight + scrollbarHeight;

      var contentWidth = this._getContentWidth();
      var clientWidthTooSmall = width < contentWidth;
      var clientWidthTooSmallWithVerticalScrollbar = width < contentWidth + scrollbarWidth;

      var shouldRenderVerticalScrollbar = clientHeightTooSmall || clientWidthTooSmall && clientHeightTooSmallWithHorizontalScrollbar;
      var shouldRenderHorizontalScrollbar = clientWidthTooSmall || clientHeightTooSmall && clientWidthTooSmallWithVerticalScrollbar;

      return {
        horizontalScrollbar: shouldRenderHorizontalScrollbar,
        verticalScrollbar: shouldRenderVerticalScrollbar
      };
    }
  }, {
    key: '_startResize',
    value: function _startResize(side) {
      var _this8 = this;

      return function (_ref17) {
        var clientX = _ref17.clientX;

        document.addEventListener('mouseup', _this8._stopResize, { capture: true });
        var _props$guttersConfig = _this8.props.guttersConfig;
        _props$guttersConfig = _props$guttersConfig === undefined ? {} : _props$guttersConfig;
        var basePosition = _props$guttersConfig[side].position;

        _this8.setState({
          resize: {
            basePosition: basePosition,
            performing: true,
            side: side,
            startingPosition: clientX
          }
        });
      };
    }
  }, {
    key: '_stopResize',
    value: function _stopResize() {
      document.removeEventListener('mouseup', this._stopResize, { capture: true });
      var side = this.state.resize.side;
      var _props$guttersConfig2 = this.props.guttersConfig;
      _props$guttersConfig2 = _props$guttersConfig2 === undefined ? {} : _props$guttersConfig2;
      var _props$guttersConfig3 = _props$guttersConfig2[side];
      _props$guttersConfig3 = _props$guttersConfig3 === undefined ? {} : _props$guttersConfig3;
      var _props$guttersConfig4 = _props$guttersConfig3.onResizeEnd;
      var onResizeEnd = _props$guttersConfig4 === undefined ? function () {} : _props$guttersConfig4;
      var position = _props$guttersConfig3.position;

      this.setState({
        resize: {
          basePosition: 0,
          performing: false,
          side: '',
          startingPosition: 0
        }
      });
      onResizeEnd(position);
    }
  }, {
    key: '_switchScrollProp',
    value: function _switchScrollProp(scrollTo) {
      var _state11 = this.state;
      var horizontalTransform = _state11.horizontalTransform;
      var verticalTransform = _state11.verticalTransform;


      if (scrollTo.location.x === 0 && scrollTo.location.y === 0 || scrollTo.preserveHorizontal && scrollTo.preserveVertical) {
        return;
      }

      var x = scrollTo.preserveHorizontal ? horizontalTransform : scrollTo.location.x;
      var y = scrollTo.preserveVertical ? verticalTransform : scrollTo.location.y;

      switch (scrollTo.type) {
        case constants.scrollType.ROW:
          this.scrollRowToMiddle(y, x);
          break;
        case constants.scrollType.HEADER:
          this.scrollToHeader(y, x);
          break;
        default:
          this.scrollTo({ x: x, y: y });
          break;
      }
    }

    // public

  }, {
    key: 'scrollRowToMiddle',
    value: function scrollRowToMiddle(rowIndex) {
      var x = arguments.length <= 1 || arguments[1] === undefined ? 0 : arguments[1];
      var _props14 = this.props;
      var height = _props14.height;
      var _props14$horizontalSc = _props14.horizontalScrollConfig.scrollbarHeight;
      var scrollbarHeight = _props14$horizontalSc === undefined ? constants.HORIZONTAL_SCROLLBAR_HEIGHT : _props14$horizontalSc;
      var _state12 = this.state;
      var rowOffsets = _state12.rowOffsets;
      var shouldRender = _state12.shouldRender;
      var verticalTransform = _state12.verticalTransform;


      if (rowIndex < 0 || rowIndex >= rowOffsets.length) {
        return;
      }

      var _rowOffsets$rowIndex = rowOffsets[rowIndex];
      var rowHeight = _rowOffsets$rowIndex.height;
      var offset = _rowOffsets$rowIndex.offset;


      var adjustedHeight = shouldRender.horizontalScrollbar ? height - scrollbarHeight : height;
      adjustedHeight -= this._getBottomGutterHeight();

      var adjustedVerticalTransform = verticalTransform + this._getTopGutterHeight();
      var needsYScroll = adjustedVerticalTransform > offset || verticalTransform + adjustedHeight < offset + rowHeight;
      var y = needsYScroll ? offset - adjustedHeight / 2 : verticalTransform;

      this.scrollTo({ x: x, y: y });
    }
  }, {
    key: 'scrollTo',
    value: function scrollTo(_ref18) {
      var _ref18$x = _ref18.x;
      var x = _ref18$x === undefined ? 0 : _ref18$x;
      var _ref18$y = _ref18.y;
      var y = _ref18$y === undefined ? 0 : _ref18$y;
      var _props$onRegisteredSc = this.props.onRegisteredScrollTo;
      var onRegisteredScrollTo = _props$onRegisteredSc === undefined ? function () {} : _props$onRegisteredSc;
      var _state13 = this.state;
      var horizontalTransform = _state13.horizontalTransform;
      var verticalTransform = _state13.verticalTransform;
      var animation = this.state.animation;

      if (animation) {
        animation.stop();
      }

      if (horizontalTransform === x && verticalTransform === y) {
        return;
      }

      var scrollingToPosition = new _models.Point(x, y);

      animation = new _animationTimer.AnimationTimer().on('tick', this._getThrottledAnimationFrameFn(scrollingToPosition)).play();

      this.setState({ animation: animation, scrollingToPosition: scrollingToPosition });
      onRegisteredScrollTo();
    }
  }, {
    key: 'scrollToHeader',
    value: function scrollToHeader(headerIndex) {
      var x = arguments.length <= 1 || arguments[1] === undefined ? 0 : arguments[1];
      var lists = this.props.lists;
      var headers = this.state.headers;


      if (!lists || headerIndex >= lists.length || headerIndex < 0) {
        return;
      }

      this.scrollTo({ x: x, y: headers[headerIndex].lockPosition });
    }
  }, {
    key: 'toggleSection',
    value: function toggleSection(sectionIndex) {
      var _props15 = this.props;
      var _props15$headerType = _props15.headerType;
      var headerType = _props15$headerType === undefined ? constants.headerType.DEFAULT : _props15$headerType;
      var lists = _props15.lists;
      var oldCollapsedSections = this.state.collapsedSections;

      var stackHeaders = headerType === constants.headerType.STACKING;

      if (!lists || sectionIndex >= lists.length || sectionIndex < 0) {
        return;
      }

      var collapsedState = !oldCollapsedSections[sectionIndex];
      oldCollapsedSections[sectionIndex] = collapsedState;

      var _buildRowConfig3 = (0, _utils.buildRowConfig)(lists, stackHeaders, oldCollapsedSections);

      var avgRowHeight = _buildRowConfig3.avgRowHeight;
      var collapsedSections = _buildRowConfig3.collapsedSections;
      var contentHeight = _buildRowConfig3.contentHeight;
      var headers = _buildRowConfig3.headers;
      var partitions = _buildRowConfig3.partitions;
      var rowOffsets = _buildRowConfig3.rowOffsets;
      var rows = _buildRowConfig3.rows;

      this.setState({ avgRowHeight: avgRowHeight, collapsedSections: collapsedSections, contentHeight: contentHeight, headers: headers, partitions: partitions, rowOffsets: rowOffsets, rows: rows });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props16 = this.props;
      var className = _props16.className;
      var height = _props16.height;
      var horizontalScrollConfig = _props16.horizontalScrollConfig;
      var _props16$horizontalSc = _props16.horizontalScrollConfig;
      _props16$horizontalSc = _props16$horizontalSc === undefined ? {} : _props16$horizontalSc;
      var _props16$horizontalSc2 = _props16$horizontalSc.scrollbarHeight;
      var scrollbarHeight = _props16$horizontalSc2 === undefined ? constants.HORIZONTAL_SCROLLBAR_HEIGHT : _props16$horizontalSc2;
      var _props16$style = _props16.style;
      var style = _props16$style === undefined ? {} : _props16$style;
      var width = _props16.width;
      var wrappedWithAutoAdjust = _props16.wrappedWithAutoAdjust;
      var _state14 = this.state;
      var performing = _state14.resize.performing;
      var shouldRender = _state14.shouldRender;


      var scrollableClassName = (0, _classnames2.default)('rickscroll', {
        'rickscroll--performing-resize': performing
      }, className);
      var topWrapperStyle = !!horizontalScrollConfig && shouldRender.horizontalScrollbar ? {
        height: 'calc(100% - ' + scrollbarHeight + 'px)'
      } : undefined;

      var rickscrollStyle = wrappedWithAutoAdjust ? style : _extends({}, style, {
        height: height + 'px',
        width: width + 'px'
      });

      return _react2.default.createElement(
        'div',
        { className: scrollableClassName, style: rickscrollStyle },
        _react2.default.createElement(
          'div',
          {
            className: 'rickscroll__top-wrapper',
            key: 'top-wrapper',
            onMouseMove: this._onResize,
            onMouseUp: this._stopResize,
            onWheel: this._onMouseWheel,
            style: topWrapperStyle
          },
          this._renderContents(),
          this._renderVerticalScrollbar()
        ),
        this._renderHorizontalScrollbar()
      );
    }
  }]);

  return Scrollable;
}(_react2.default.Component);

exports.default = Scrollable;


Scrollable.propTypes = {
  className: _react.PropTypes.string,
  disableBidirectionalScrolling: _react.PropTypes.bool,
  dynamicColumn: customTypes.column,
  guttersConfig: customTypes.guttersConfig,
  headerType: customTypes.headerType,
  height: _react.PropTypes.number.isRequired,
  horizontalScrollConfig: customTypes.horizontalScrollConfig,
  light: _react.PropTypes.bool,
  list: customTypes.list,
  lists: customTypes.lists,
  onRegisteredScrollTo: _react.PropTypes.func,
  scrollTo: customTypes.scrollTo,
  style: _react.PropTypes.object,
  verticalScrollConfig: customTypes.verticalScrollConfig,
  width: _react.PropTypes.number.isRequired,
  wrappedWithAutoAdjust: _react.PropTypes.bool
};